com.fasterxml.jackson.dataformat.cbor

## Enum CBORGenerator.Feature

- java.lang.Object
- - java.lang.Enum<CBORGenerator.Feature>
  - - com.fasterxml.jackson.dataformat.cbor.CBORGenerator.Feature

All Implemented Interfaces:
  com.fasterxml.jackson.core.FormatFeature, Serializable, Comparable<CBORGenerator.Feature>

Enclosing class:
  CBORGenerator

    public static enum CBORGenerator.Feature
    extends Enum<CBORGenerator.Feature>
    implements com.fasterxml.jackson.core.FormatFeature

Enumeration that defines all togglable features for CBOR generator.

### Enum Constant Summary

Enum Constants
Enum Constant and Description
`WRITE_MINIMAL_INTS` Feature that determines whether generator should try to use smallest (size-wise) integer representation: if true, will use smallest representation that is enough to retain value; if false, will use length indicated by argument type (4-byte for `int`, 8-byte for `long` and so on).
`WRITE_TYPE_HEADER` Feature that determines whether CBOR "Self-Describe Tag" (value 55799, encoded as 3-byte sequence of `0xD9, 0xD9, 0xF7`) should be written at the beginning of document or not.

### Field Summary

Fields
`protected boolean` `_defaultState`
`protected int` `_mask`

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`static int` `collectDefaults()` Method that calculates bit set (flags) of all features that are enabled by default.
`boolean` `enabledByDefault()`
`boolean` `enabledIn(int flags)`
`int` `getMask()`
`static CBORGenerator.Feature` `valueOf(String name)` Returns the enum constant of this type with the specified name.
`static CBORGenerator.Feature[]` `values()` Returns an array containing the constants of this enum type, in the order they are declared.

### Methods inherited from class java.lang.Enum

`clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

### Enum Constant Detail

#### WRITE_MINIMAL_INTS

    public static final CBORGenerator.Feature WRITE_MINIMAL_INTS

Feature that determines whether generator should try to use smallest (size-wise) integer representation: if true, will use smallest representation that is enough to retain value; if false, will use length indicated by argument type (4-byte for `int`, 8-byte for `long` and so on).

#### WRITE_TYPE_HEADER

    public static final CBORGenerator.Feature WRITE_TYPE_HEADER

Feature that determines whether CBOR "Self-Describe Tag" (value 55799, encoded as 3-byte sequence of `0xD9, 0xD9, 0xF7`) should be written at the beginning of document or not.

Default value is `false` meaning that type tag will not be written at the beginning of a new document.

Since:
  2.5

### Field Detail

#### _defaultState

    protected final boolean _defaultState

#### _mask

    protected final int _mask

### Method Detail

#### values

    public static CBORGenerator.Feature[] values()

Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

    for (CBORGenerator.Feature c : CBORGenerator.Feature.values())
        System.out.println(c);

Returns:
  an array containing the constants of this enum type, in the order they are declared

#### valueOf

    public static CBORGenerator.Feature valueOf(String name)

Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `IllegalArgumentException` - if this enum type has no constant with the specified name
  `NullPointerException` - if the argument is null

#### collectDefaults

    public static int collectDefaults()

Method that calculates bit set (flags) of all features that are enabled by default.

#### enabledByDefault

    public boolean enabledByDefault()

Specified by:
  `enabledByDefault` in interface `com.fasterxml.jackson.core.FormatFeature`

#### enabledIn

    public boolean enabledIn(int flags)

Specified by:
  `enabledIn` in interface `com.fasterxml.jackson.core.FormatFeature`

#### getMask

    public int getMask()

Specified by:
  `getMask` in interface `com.fasterxml.jackson.core.FormatFeature`